## nvidia-cuda-toolkit 11.0.3

=== debian/changelog ===
nvidia-cuda-toolkit (11.0.3-1ubuntu1) groovy; urgency=medium

  * Update libcuda1 availability for groovy (LP: #1900627)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 20 Oct 2020 12:30:55 +0000

nvidia-cuda-toolkit (11.0.3-1build1) groovy; urgency=high

  * No change rebuild against glibc 2.32

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 10 Sep 2020 14:58:44 +0200

nvidia-cuda-toolkit (11.0.3-1) experimental; urgency=medium

  * New upstream release 11.0 Update 1 (Aug 2020).
  * Fix separate binary-indep build.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 13 Aug 2020 09:19:03 +0200

nvidia-cuda-toolkit (11.0.2-1) experimental; urgency=medium

  * New upstream release 11.0 (May 2020).
    - Provides nsight-systems for ppc64el.
    - Adds support for arm64 (excluding nvidia-{,visual-}profiler).
      (Closes: #934666)
  * Drop packages and infrastructure for removed components: nvidia-nsight,
    libnppicom10, libnvgraph10.
  * Runtime SOVERSION bump: 10.2 => 11.0, rename core library packages.
  * SOVERSION bump: 10 => 11, rename application library packages.
  * Some applications libraries are still at SOVERSION 10.
  * Update symbols control files.
  * Add gcc-9 (default) and clang-9 as supported compiler alternatives.
    (Closes: #955524)
  * Remove non-C++14 compiler alternatives: gcc < 5, clang < 6.
  * Adjust installation paths for changed upstream layout.
  * Refresh patches.
  * Update Build-Depends.
  * Use system libraries libcrypto.so.1.1/libssl.so.1.1.
  * Fix building cuda-gdb (now based on gdb-8.2).
  * Ship (or ignore) new files.
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Aug 2020 22:02:14 +0200

nvidia-cuda-toolkit (10.2.89-4) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 07 Aug 2020 02:00:02 +0200

nvidia-cuda-toolkit (10.2.89-3) experimental; urgency=medium

  * Merge changes from 10.1.243-8.
  * Rename nvidia-cuda-doc to nvidia-cuda-toolkit-doc.
  * Split nsight-compute-target from nsight-compute.
  * Split nsight-systems-target from nsight-systems.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 28 Jul 2020 20:21:23 +0200

nvidia-cuda-toolkit (10.2.89-2) experimental; urgency=medium

  * Merge changes from 10.1.243-7.
  * nsight-compute: Ignore missing dependencies for unused QtWebEngineProcess.
  * libcupti10.2: Add Breaks+Replaces: libcupti10.1 due to file conflict.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Jul 2020 20:44:39 +0200

nvidia-cuda-toolkit (10.2.89-1) experimental; urgency=medium

  * New upstream release 10.2 (Nov 2019).
  * Refresh patches and fix more typos.
  * Install new/renamed/moved/... files.
  * Runtime SOVERSION bump: 10.1 => 10.2, rename core library packages.
  * Update symbols control files.
  * Ship both nvvm and nvvmx, do not build libnvvm3.
  * Update Lintian overrides.
  * Try to use the system library as replacement for the missing
    libQt5WebEngineCore.so.5.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 06 Jun 2020 01:24:33 +0200

nvidia-cuda-toolkit (10.1.243-8) unstable; urgency=medium

  * Use vendor-specific alternatives for libcuda.so.1 and libnvidia-ml.so.1.
  * Fix the no-libcuda1 virtual package generation for Ubuntu.
  * Fix building cuda-gdb with GCC-10 by adding -fcommon.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jul 2020 21:50:39 +0200

nvidia-cuda-toolkit (10.1.243-7) unstable; urgency=medium

  * Switch build-dependency to libasound2-dev to avoid pulling in the virtual
    libasound2 provided by liboss4-salsa-asound2.
  * libcupti10.1: Add Provides/Conflicts/Replaces: libnvperf to avoid file
    conflicts on unversioned libnvperf_host.so, libnvperf_target.so.
  * cuda-gdb: Fix linking against python3.
  * Use doctools.js and searchtools.js from libjs-sphinxdoc.
  * Tighten libthrust-dev dependency.
  * Use dh-exec for arch-dependent installation.
  * nsight-systems: Reduce Qt5 library footprint.
  * Reactivate watch file.
  * Overhaul get-orig-source target.
  * Overhaul packaging in preparation for CUDA 11.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Jul 2020 14:10:08 +0200

nvidia-cuda-toolkit (10.1.243-6) unstable; urgency=medium

  * nsight-systems: Do not ship libstdc++.so.6, libhyphen.so.0.
  * Use vendor specific jre dependency substitutions.
  * Adjust B-D to use libjpeg62-dev on Ubuntu.  (Closes: #962263)
  * Do not build nvidia-openjdk-8-jre on Ubuntu.
  * Use versioned openjdk-8-jre component tarballs.
  * nvidia-openjdk-8-jre: Use a snapshot of openjdk-8-jre (8u252-b09-1~deb9u1)
    from Debian stretch which is backportable to buster.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 05 Jun 2020 19:15:23 +0200

nvidia-cuda-toolkit (10.1.243-5) unstable; urgency=medium

  * Merge changes from 10.1.168-11.
  * Update Lintian overrides.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Jun 2020 09:54:22 +0200

nvidia-cuda-toolkit (10.1.243-4) experimental; urgency=medium

  * Merge changes from 10.1.168-9.
  * Use updated nvidia-openjdk-8-jre on amd64 and ppc64el for
    nvidia-visual-profiler and nvidia-nsight.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 19 May 2020 00:32:39 +0200

nvidia-cuda-toolkit (10.1.168-11) unstable; urgency=medium

  * Do not ship gdb headers conflicting with binutils-dev.  (Closes: #961263)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 25 May 2020 13:57:38 +0200

nvidia-cuda-toolkit (10.1.168-10) unstable; urgency=medium

  * Build cuda-gdb from source.  (Closes: #898045)
    ./configure flags are based on gdb 7.12 (stretch).

 -- Andreas Beckmann <anbe@debian.org>  Wed, 20 May 2020 22:45:19 +0200

nvidia-cuda-toolkit (10.1.168-9) unstable; urgency=medium

  * Switch to debhelper-compat (= 13).
  * Override executable-in-usr-lib.
  * Add targets for creating component tarballs with openjdk-8-jre snapshots.

